

	/* OJO: it does not find patterns that are in a border!
		I have estimated 2*HSIZE enough...
		I think I can miss a pattern that matches at the end.
	*/

#include "format.h"
#include "multipat.h"
#include "cut.h"

typedef struct
   { char_type c;
     unsigned short ref;
     unsigned short length;
     unsigned long from;
   } block;

block Blocks [1+2*HSIZE];
block *blocks = Blocks+1;

#define REPORT(x) /* { printf("Match at %i\n",x); } */

int* B[256];

Multi M;
Cut C;

int preproc (byte *patt, int len, int k)

   { int c,i,j,m,I;
     int *BB;
     makeCut (patt,len,k,k+1,&C);
     prepMulti (&M,C.ps,k+1);
     m = M.minlen;
     BB = (void*) malloc (256*m*sizeof(int));
     for (c=0;c<256;c++) B[c] = BB + c*m;
     for (i=0;i<m;i++)
         for (c=0;c<256;c++)
             B[c][i] = i+1;
     for (i=0;i<m;i++)
        for (j=i;j<m;j++)
           for (I=0;I<=k;I++)
              B[C.ps[I][i]][j] = j-i;
     return m;
   }

	/* fills backward, but not before otpos */

int otpos;
uchar *fill (int tpos, uchar *pos, int len, int afrom, int afrest)

   { do { while (len && blocks[afrom].length)
	     { if (--tpos < otpos) return (tpos>=0)? pos-len : pos;
	       *--pos = blocks[afrom].c;
	       afrom = blocks[afrom].ref;
	       len--;
	     }
	  afrom = afrest--;
	}
     while (len && blocks[afrom].length);
     return pos;
   }

	/* a mechanism to be able to read plen+k chars ahead */

int bsize,bfrom,bto;
code_int *buff;

code_int GetCode (void)
   { code_int ret,j;
     if (bfrom == bto)
	{ bfrom = bto = 0;
	  while (bto != bsize)
	     { if ((j = buff[bto++] = getcode()) == -1) break;
	       if (j == Clear) free_ent = FirstFree - 1;
	       else if (free_ent < maxmaxcode) free_ent++;
	     }
	  if (bto == bsize) bto = 0;
	}
     ret = buff[bfrom];
     bfrom++; if (bfrom == bsize) bfrom = 0;
     return ret;
   }

void FillCodes (void)
   { int nexto;
     code_int j;
     while (1)
        { nexto = bto+1; if (nexto == bsize) nexto = 0;
	  if (nexto == bfrom) break;
	  if ((j = buff[bto] = getcode()) == -1) { bto = nexto; break; }
	  if (j == Clear) free_ent = FirstFree - 1;
	  else if (free_ent < maxmaxcode) free_ent++;
	  bto = nexto;
	}
   }

	/* finds and report matches */

unsigned long count;

uchar *Pat;

void findMatch (int k, uchar *from, uchar *to, int tpos)

   { //static int *C = NULL;
     static int m;
     //register int i,oC,nC;
     //register char c;
     register mask P,M,X,U,Y,Ebit;
     register int Cscore;
     static mask sP,sM;
     static int sCscore = -1;
     static mask Pc[256];

/* I preferred to use Myers' code here */

		/* primera vez */
//   if (C == NULL)
//	{ m = strlen(Pat+1);
//	  C = (void*)malloc ((m+1)*sizeof(int));
//         for (i=0;i<=m;i++) C[i] = i;
//	}
     if (sCscore == -1)
        { int i;
          m = strlen(Pat);
          for (i=0; i<256; i++) Pc[i] = 0;
          for (i=0; i<m; i++)
              Pc[Pat[i]] |= 1 << i;
          sP = -1; sM = 0; sCscore = m;
          }

		/* (re)initialize */
     if (otpos < tpos)
	{ // for (i=0;i<=m;i++) C[i] = i;
	  P = -1; M = 0; Cscore = m;
	}
     else 
	{ from += otpos-tpos;
	  tpos = otpos;
	  P = sP; M = sM; Cscore = sCscore;
	}
     if (from > to) return;
		/* process this area */
     Ebit = ((mask)1 << (m-1));
     while (from != to)
	{ U = Pc[*from++];
          X  = (((U & P) + P) ^ P) | U;
          U |= M;
          Y = P;
          P = M | ~ (X | Y);
          M = Y & X;
          if (P & Ebit) Cscore++;
          else if (M & Ebit) Cscore--;
          Y = P << 1;
          P = (M << 1) | ~ (U | Y);
          M = Y & U;
          if (Cscore <= k)
             { REPORT (tpos); count++; }
//	{ c = *from++;
//	  oC = nC = 0;
//	  for (i=1;i<=m;i++)
//	     { if (Pat[i] == c) nC = oC;
//	       else { if (oC < nC) nC = oC;
//		      if (C[i] < nC) nC = C[i];
//		      nC++;
//		    }
//	       oC = C[i]; C[i] = nC;
//	     }
//	  if (nC <= k) { REPORT(tpos); count++; }
	  tpos++;
	}
     sP = P; sM = M; sCscore = Cscore;
     otpos = tpos;
   }
	  
/*
 * Searches stdin.
 */

unsigned long search (char *patt, int K)

   { register code_int oldj, i, k, j;
     register int m,c;
     register int length;
     register long tpos,rpos;
     register int offset,shift;
     int afrom,afrest,cual;
     static int sm = 0;
     static int plen;
     static uchar *test;
     static uchar *atest;

     if (!sm) 
	{ plen = strlen(patt);
	  Pat = patt; // Pat--;
          sm = preproc (patt,plen,K);
          atest = (void*)malloc (2*(plen+K));
          test = atest + plen + K;
	  bsize = plen+K+1;
	  buff = (void*)malloc (bsize*sizeof(code_int));
        }
     m = sm;
     bfrom = bto = 0; otpos = 0;
	 
        /* searching */

                /* tpos = pattern pos, rpos = text read */
     count = 0; tpos = 0; rpos = 0;

     for (j=-1; j<FirstFree; j++) {
	 blocks[j].ref = -1;
	 blocks[j].c = j+1;
	 blocks[j].length = 0;
	 blocks[j].from = -1;
     }
     i = free_ent = FirstFree;

     c = oldj = blocks[--i].c = getcode();
     if (oldj == -1) return count;

     while (1)
        { readBlocks:
          if (rpos - tpos < m)
            while (1)
             { if ((j = GetCode()) == -1)  goto endText;
	       if (j == Clear)
	          { i = FirstFree - 1;
	            if ( (j = GetCode ()) == -1 ) goto endText;
		    blocks[--i].c = j;
	          }
	       c = blocks[j-1].c;
	       i++;
	       blocks[i].ref = oldj;
	       blocks[i].c = c;
	       blocks[i].from = rpos;
	       length = blocks[i].length = blocks[oldj].length+1;
	       oldj = j;
               rpos += length;
               if (rpos-tpos >= m) break;
               tpos += B[c][rpos-tpos];
             }

                /* now I've read one extra block. try to shift */

          j = i;
          while (1)
            { offset = blocks[j].from-tpos;
              if (offset < 0) break;
              shift = B[blocks[--j].c][offset];
              if (shift > 0) { tpos += shift; goto readBlocks; }
            }

                /* unable to shift by explicit characters.
                   try implicit characters */
          j = i-1;
          while (1)
            { offset = blocks[j].from-tpos;
              length = offset - 1 + blocks[j].length;
              k = j--;
              if (length < 0) goto expandLast;
              while (length > offset)
                 { k = blocks[k].ref;
                   shift = B[blocks[k].c][length];
                   if (shift > 0) { tpos += shift; goto readBlocks; }
                   if (--length < 0) goto expandLast;
                 }
            }

                /* only the last (i-th) block remains to be tested */

          expandLast:
          k = i;
          offset = blocks[i].from-tpos;
          length = 1 + offset + blocks[i].length;
          while (--length > m)
              k = blocks[k].ref;
          while ((--length > offset) && (length >= 0))
             { k = blocks[k].ref;
	       test[length] = blocks[k].c;
               shift = B[blocks[k].c][length];
               if (shift > 0) { tpos += shift; goto readBlocks; }
             }

                /* it passed all the tests, check the match */

			/* complete test[] with explicit chars */
          j = i-1; k = blocks[k].ref;
          while (1)
            { offset = blocks[j].from-tpos;
              length = offset + blocks[j].length;
              if (length < 0) break;
              k = j--;
              while (length > offset)
	         { test[length] = blocks[k].c;
                   k = blocks[k].ref;
                   if (--length < 0) break;
                 }
            }
	  afrom = k; afrest = j;
          
          cual = checkMulti(&M,test);
	  if (cual != -1)
	     {   /* ok, we have a match of a subpattern */
	       uchar *from;
	       int ofrom,frem,flen,ni,nj,noldj;
	       from = fill (tpos,test,C.aclen[K /*cual*/ -1]+K,afrom,afrest);
	       FillCodes ();
	       flen = blocks[i].from+blocks[i].length-tpos-m;
	       // frem = plen-C.aclen[ 0 /* cual*/]+K-flen;
	       frem = plen-C.aclen[cual-1]-C.len[cual]+K-flen;
	       ni = i; noldj = oldj; ofrom = bfrom; 
	       while (frem > 0)
		 { nj = GetCode();
		   if ((nj == -1) || (nj == Clear)) break;
	           c = blocks[nj-1].c;
	           ni++;
	           blocks[ni].ref = noldj;
	           blocks[ni].c = c;
	           length = blocks[ni].length = blocks[noldj].length+1;
		   noldj = nj;
		   frem -= length; flen += length;
		 }
	       k = blocks[ni].ref;
	       while (frem++ < 0) { k = blocks[k].ref; flen--; }
	       fill (tpos+m+flen,test+m+flen,flen,k,ni-1);
	       bfrom = ofrom; /* unread! */
	       findMatch(K,from,test+m+flen,tpos-(test-from));
	     }
          tpos++;
        }
     endText:
     return count;
   }


